// FLORA variation VI
// built with Processing .68
// by Alessandro Capozzo
// www.abstract-codex.net
float vectX=0;
float vectY=0;
float posX=100;
float posY=100;
float noiseM;
float pos;
int num;
int counter;
cell[] amount;
void setup(){
  size(600,600);

  background(230,230,220);
  noFill();
  startAgain(5,2,12,3);
}
void startAgain(int n,int nRaggio, int coefN, int coefR){
  int startN=n;
  int startCoefN=coefN;
  int startCoefR=coefR;
  int startRadius=nRaggio;
  background(230,230,220);
  num=4+(int)(random(startN));
  vectX=0;
  vectY=0;
  posX=300;
  posY=300;
  float numAng=TWO_PI/num;
  float numAngR=PI/(num*startRadius);
  float distP;
  amount=new cell[num];
  for (int index=0;index<num;index++){
    distP=80+random(startCoefN)*8;
    float newAng=numAng*index+(random(startCoefR)*numAngR);
    amount[index]=new cell(newAng,distP,100,posX,posY);
  }
}
void mouseReleased(){
  startAgain(5,4,12,10);
}
void loop(){
  // background(230,230,220);
  counter++;
  for(int i=0; i<num; i++) {

    if (amount[i].stopMe){
      if (amount[i].checkDist()){
        amount[i].draw();
      } else {
        float q=(PI*.01f)*random(15);
        float nang=amount[i].Ang_target-(q);
        float x=amount[i].posX;
        float y=amount[i].posY;
        float a=amount[i].alphaPar;
        float d=amount[i].maxDist;
        d=d-((d*.1f)*random(4));
        cell pippo=new cell(nang,d,a, x, y);
        add(pippo);
        //ramo 2
        nang=amount[i].Ang_target+((PI*.2f)-q);
        x=amount[i].posX;
        y=amount[i].posY;
        d=amount[i].maxDist;
        d=d-((d*.1f)*random(4));
        pippo=new cell(nang,d,a, x, y);
        add(pippo);
        removeA(i);
      }

    }
  }
}
// this piece of code is based on a Ben Fry's example
void add(cell what) {
  if (num == amount.length) {
    cell temp[] = new cell[num<<1];
    System.arraycopy(amount, 0, temp, 0, num);
    amount = temp;
  }
  amount[num++] = what;
}
//
void removeA(int who) {
  amount[who].stopMe=false;
}
class cell{
  float vectY,vetX,noiseM;
  float Ang_target;
  float posX,posY;
  float coef;
  float oldx,oldy;
  float alphaPar;
  float originX,originY;
  float maxDist;
  float noiseScale=0.008;
  float ang=TWO_PI/12;
  float dim;
  float bezPar1;
  float bezPar2;
  public boolean stopMe;
  cell (float ang,float distP, float range, float myX, float myY){
    Ang_target=ang;
    posX=myX;
    posY=myY;
    originX=myX;
    originY=myY;
    vectX=0;
    vectY=0;
    coef=(distP/50)*(ang/ang);
    alphaPar=range;
    maxDist=distP;
    stopMe=true;
  }
  boolean checkDist(){
    if (dist(posX,posY,originX,originY)<maxDist){
      return true;
    } else {
      return false;

    }
  }
  void draw(){
    noiseM=noise(posX,posY,Ang_target);
    pos=Ang_target;
    vectY=sin(pos)+(coef*(noiseM-.5f));
    vectX=cos(pos)+(coef*(noiseM-.5f));
    oldx=posX;
    oldy=posY;
    posX+=vectX;
    posY+=vectY;
    dim=0;
    for(int x=0; x<maxDist; x++) {
      dim=dim+ang;
      float noiseVal = noise((x)*noiseScale,(maxDist*.5)*noiseScale);
      float angN=(noiseVal)*(Ang_target*.04);
      color c=color(215-noiseM*noiseVal,210-80*noiseVal,150-maxDist*noiseVal,50-alphaPar);
      bezPar1=posX+sin(x*noiseVal)*(x*angN);
      bezPar2=posY+cos(x)*(x*angN);
      stroke(c);
      beginShape(LINE_STRIP);
      bezierVertex(posX, posY);
      bezierVertex(bezPar1,bezPar2);
      bezierVertex(bezPar1,bezPar2);
      bezierVertex(posX+sin(x)*(x*.8),posY+cos(x)*(x*.8));
      endShape();

    }
    alphaPar=alphaPar-.24f;
    if((alphaPar<=50)||(maxDist<2)){
      stopMe=false;
    }

  }
}

